#ifndef PM_DNSSD_H
#define PM_DNSSD_H 1

/**
 * Answer from DNS-SD
 * one direction list of found services
 */
typedef struct dnssd_share_t dnssd_share_t;

struct dnssd_share_t {
    char *hostname; // server
    char *volume; // path to share on server
    char *sname;  // service name (unique in DNS-SD network)

    struct dnssd_share_t *next;
};

/** Request from pam_mount */
typedef struct PMRequest PMRequest;

struct PMRequest {
    int terminate_on_cache_exhausted;
    int ignore_local;
    const char *domain; /** In most cases you want to pass NULL here for the default domain */
    const char *stype;  /** Example: _smb._tcp for CIFS */
};

/**
 * Return list of found anonced services in DNS-SD (Avahi, Zeroconf, etc..)
 * List MUST be free with dnssd_share_list_free()
 */
extern dnssd_share_t * dnssd_lookup(const PMRequest *, const char * key);

extern void dnssd_share_list_free(dnssd_share_t *s);

#endif /* PM_DNSSD_H */
